﻿using Microsoft.AspNetCore.Hosting;
using Microsoft.Extensions.Configuration;
using Abp.Modules;
using Abp.Reflection.Extensions;
using BCS.BMC.Configuration;

namespace BCS.BMC.Web.Host.Startup
{
    [DependsOn(
       typeof(BMCWebCoreModule))]
    public class BMCWebHostModule: AbpModule
    {
        private readonly IWebHostEnvironment _env;
        private readonly IConfigurationRoot _appConfiguration;

        public BMCWebHostModule(IWebHostEnvironment env)
        {
            _env = env;
            _appConfiguration = env.GetAppConfiguration();
        }

        public override void Initialize()
        {
            IocManager.RegisterAssemblyByConvention(typeof(BMCWebHostModule).GetAssembly());
        }
    }
}
